--special thanks to "Gourmet Extravaganza" mod, which helped me understand 
--how to implement certain things such as the giantgrub loot :) and
--user skittlessour for explaining how to use modmain instead of just rewriting the
--script files
--local TUNING = GLOBAL.TUNING
TUNING.OPTION_WEEVOLE = GetModConfigData("WEEVOLE")
TUNING.OPTION_PEA = GetModConfigData("PEA")
TUNING.OPTION_BAT = GetModConfigData("COWL")
TUNING.OPTION_VAMP = GetModConfigData("VAMP")
TUNING.SPRINKLER= GetModConfigData("SPRINK")
TUNING.INGR = GetModConfigData("INGR")
TUNING.MAGNIFYING_GLASS_USES = GetModConfigData("MAGN")

if TUNING.OPTION_WEEVOLE == true then
TUNING.WEEMOD = 0.7
else
TUNING.WEEMOD = 0.6
end
if (GetModConfigData("VINE") == true) then 
	TUNING.ENTVIN = 2
	TUNING.DORVIN = 1
else
	TUNING.ENTVIN = 4
	TUNING.DORVIN = 2
end
TUNING.BATREPAIR = TUNING.OPTION_BAT*1
TUNING.PEAREPAIR = TUNING.OPTION_PEA*1
local venusfoodprefs = {"MEAT"}
local vinefoodprefs = { "MEAT", "INSECT"}
--, "GENERIC" , "SEEDS", "VEGGIE"
local SetSharedLootTable = GLOBAL.SetSharedLootTable
local pairs = GLOBAL.pairs
local require = GLOBAL.require
local STRINGS = GLOBAL.STRINGS
local cooking = require "cooking"
local recipes = cooking.recipes.cookpot
Ingredient = GLOBAL.Ingredient
RECIPETABS = GLOBAL.RECIPETABS
Recipe = GLOBAL.Recipe
TECH = GLOBAL.TECH
RECIPE_GAME_TYPE = GLOBAL.RECIPE_GAME_TYPE
--SaveGameIndex = GLOBAL.SaveGameIndex

if (TUNING.OPTION_WEEVOLE == true) then
Recipe("armor_weevole", {Ingredient("weevole_carapace", 6), Ingredient("chitin", 3)}, RECIPETABS.WAR, TECH.SCIENCE_TWO, RECIPE_GAME_TYPE.PORKLAND)
end
Recipe("spear_poison", {Ingredient("spear", 1), Ingredient("venomgland", 1) }, RECIPETABS.WAR,  TECH.SCIENCE_ONE, {RECIPE_GAME_TYPE.SHIPWRECKED,RECIPE_GAME_TYPE.PORKLAND})
    --if SaveGameIndex:IsModePorkland() then
Recipe("icemaker", {Ingredient("heatrock", 1), Ingredient("bamboo", 5), Ingredient("transistor", 2)}, RECIPETABS.SCIENCE,  TECH.SCIENCE_TWO, {RECIPE_GAME_TYPE.SHIPWRECKED,RECIPE_GAME_TYPE.PORKLAND}, "icemaker_placer")
--end
Recipe("antivenom", {Ingredient("venomgland", 1), Ingredient("lotus_flower", 1), Ingredient("vine", 2) }, RECIPETABS.REFINE,  TECH.SCIENCE_ONE, RECIPE_GAME_TYPE.PORKLAND)
STRINGS.RECIPE_DESC.NEEDLESPEAR = "It's uhh, it's close enough."
Recipe("needlespear",{Ingredient("bill_quill", 1), Ingredient("vine", 1)}, RECIPETABS.REFINE, TECH.SCIENCE_TWO, RECIPE_GAME_TYPE.PORKLAND)
Recipe("armorcactus", {Ingredient("needlespear", 3), Ingredient("armorwood", 1)}, RECIPETABS.WAR, TECH.SCIENCE_TWO, {RECIPE_GAME_TYPE.SHIPWRECKED,RECIPE_GAME_TYPE.PORKLAND})
if (GetModConfigData("OINC") == true ) then
STRINGS.RECIPE_DESC.OINC = "Split a coin into change."
STRINGS.RECIPE_DESC.OINC10 = "How is this possible??"
Recipe("oinc",{Ingredient("oinc10", 1)}, RECIPETABS.REFINE, TECH.NONE, {RECIPE_GAME_TYPE.SHIPWRECKED,RECIPE_GAME_TYPE.PORKLAND},nil,nil,nil,10)
Recipe("oinc10",{Ingredient("oinc100", 1)}, RECIPETABS.REFINE, TECH.NONE, {RECIPE_GAME_TYPE.SHIPWRECKED,RECIPE_GAME_TYPE.PORKLAND},nil,nil,nil,10)
end
modimport("scripts/mrecipe.lua")
if (GetModConfigData("RECIPE")==true) then
for k, recipe in pairs(GLOBAL.require("mrecipe")) do
AddCookerRecipe("cookpot",recipe) end
end

if (TUNING.INGR == true) then
AddIngredientValues({"boneshard"}, {inedible=1})
--each have seperate levels of filter power which allows using combinations
--2 nuts + piko works (can only make normal tea)
--2 pikos 
--1 orange piko
AddIngredientValues({"teatree_nut_cooked"}, {filter=.5}, true)
AddIngredientValues({"piko"}, {filter=1}, true)
AddIngredientValues({"piko_orange"}, {filter=2}, true)
end

local function grubloot(inst)
    inst:AddTag("groundpoundimmune")
if (GetModConfigData("GRUBLOOT") ~= 1) then
	if ((GetModConfigData("GRUBLOOT") == 3) and (GetModConfigData("BUGS") ~= 1 )) then
      SetSharedLootTable('giantgrub',{
--100 chance, 150 chance, 25 chance, 5 chance
--basic loot is always 2 meats and 1 chitin with chance for extra
    {'monstermeat', 1.000},
    {'monstermeat', 1.000},
	{'chitin', 1.000 },
	{'chitin', 0.500 },
    {'jellybug',  0.250},
	{'slugbug', 0.050},
        })
	else       SetSharedLootTable('giantgrub',{
    {'monstermeat', 1.000},
    {'monstermeat', 1.000},
	{'chitin', 1.000 },
	{'chitin', 0.500 },
        })
end
		inst:ListenForEvent("death", function(inst)
	local pt = inst:GetPosition()
		inst.components.lootdropper:DropLoot(pt)
	end)
        inst.components.lootdropper:SetChanceLootTable('giantgrub')
end
end
for prefab, func in pairs{
	vampirebatcave = function(inst) 
	if (TUNING.OPTION_VAMP ~= 0) then
	inst:AddComponent( "childspawner" )
	inst.components.childspawner:SetRegenPeriod(TUNING.TOTAL_DAY_TIME/TUNING.OPTION_VAMP)
	inst.components.childspawner:SetSpawnPeriod(15)
	inst.components.childspawner:SetMaxChildren(TUNING.OPTION_VAMP)
	inst.components.childspawner.childname = "vampirebat"
        inst.components.childspawner:StartSpawning()
end
end,
	waterdrop = function(inst)
	if inst.components.edible then
		inst.components.edible.foodtype = "MEAT"  
    		inst.components.edible.foodstate = "COOKED"   
end
end,
	chitin = function(inst)
	inst.components.stackable.maxsize = TUNING.STACK_SIZE_MEDITEM
end,
	batwing = function(inst)
		if (TUNING.OPTION_BAT ~= 1) then
		inst:AddComponent("fuel") 
		inst.components.fuel.fueltype = "BAT"
		inst.components.fuel.fuelvalue = TUNING.BATHAT_PERISHTIME * TUNING.BATREPAIR
end
end,
	peagawkfeather = function(inst)
		if (TUNING.OPTION_PEA ~= 1) then
		inst:AddComponent("fuel") 
		inst.components.fuel.fueltype = "PEA"
		inst.components.fuel.fuelvalue = TUNING.GASMASK_PERISHTIME * TUNING.PEAREPAIR
end
end,
	sprinkler = function(inst)
	if inst.components.fueled then
		inst.components.fueled:InitializeFuelLevel(TUNING.SPRINKLER_MAX_FUEL_TIME*TUNING.SPRINKLER)
end
end,

	gashat = function(inst)
		inst:AddTag("gasmask")
end,
	
	gasmaskhat = function(inst)
		 if (inst.components.fueled and (TUNING.OPTION_PEA ~= 1)) then
			inst.components.fueled.fueltype = "PEA"
			inst.components.fueled.accepting = true
end
end,
	
	bathat = function(inst)
		 if (inst.components.fueled and (TUNING.OPTION_BAT ~= 1)) then
			inst.components.fueled.fueltype = "BAT"
			inst.components.fueled.accepting = true
end
end,

	pig_ruins_creeping_vines = function(inst)
        inst.components.hackable.hacksleft = TUNING.DORVIN	
        inst.components.hackable.maxhacks = TUNING.DORVIN
end, 
	pig_ruins_entrance = function(inst)
        inst.components.hackable.hacksleft = TUNING.ENTVIN	
        inst.components.hackable.maxhacks = TUNING.ENTVIN
end,
plantmeat = function(inst)
    inst:AddComponent("dryable")
    inst.components.dryable:SetProduct("smallmeat_dried")
    inst.components.dryable:SetDryTime(TUNING.DRY_FAST)
end,
	armor_weevole = function(inst)
	 inst.components.armor:InitCondition(150*(TUNING.WEEMOD*10), TUNING.WEEMOD)
end,
	mean_flytrap = function(inst)
inst:AddTag("plantkin")
local function OnEat(inst, food)
	if inst.currentTransform < 4 then 			
		inst.growtask = inst:DoTaskInTime(0.5, 
			function() 
				inst:DoTransform() 
				inst.growtask:Cancel()
				inst.growtask = nil
			end)		
	end 
	
end 
	local function CanEatFn(inst, food)
	return food.prefab ~= "plantmeat" and food.prefab ~= "plantmeat_cooked" and food.prefab ~= "venus_stalk"
end
	if inst.components.eater then
	inst.components.eater:SetCanEatTestFn(CanEatFn)
	inst.components.eater.foodprefs = venusfoodprefs
	inst.components.eater.oneatfn = OnEat
end
end,

	jellybug = function(inst) 
if inst.components.edible then
inst:RemoveComponent("burnable")
inst:RemoveComponent("propagator")
    inst:RemoveTag("burnable")
end
end,
	slugbug = function(inst) 
if inst.components.edible then
inst:RemoveComponent("burnable")
inst:RemoveComponent("propagator")
    inst:RemoveTag("burnable")
end
end,
	pigbandit = function(inst)
if inst.components.lootdropper then
    inst.components.lootdropper:AddRandomLoot("meat", 3)
    inst.components.lootdropper:AddRandomLoot("pigskin", 1)
    inst.components.lootdropper.numrandomloot = 1
end
end,
	spider_monkey_tree_tall = function(inst)
	inst.components.lootdropper:AddChanceLoot("silk", 1)
end,
	grabbing_vine = function(inst)
inst:AddTag("plantkin")
	local function CanEatFn(inst, food)
	return food.prefab ~= "plantmeat" and food.prefab ~= "plantmeat_cooked" and food.prefab ~= "venus_stalk" 
end
	if inst.components.eater then
	inst.components.eater:SetCanEatTestFn(CanEatFn)
	inst.components.eater.foodprefs = vinefoodprefs
	inst.components.eater.ablefoods = { "MEAT",  "INSECT"}
end
end
} do AddPrefabPostInit(prefab, func) end
AddPrefabPostInit("giantgrub", grubloot)
AddComponentPostInit("kramped", function(self)
	local onkilledother = self.onkilledother
	self.onkilledother = function(self, victim, ...)
		if victim and victim.prefab then 
			if victim.prefab == "pigman_mayor" or victim.prefab == "pigman_queen" then
				self:OnNaughtyAction(50)
			end 
		end
		return onkilledother(self, victim, ...)
	end
end)
require ("components/workable")
local weighted_random_choice = GLOBAL.weighted_random_choice
local rftrees = {
"rainforesttree_stump", "rainforesttree_tall"}
local function dig_up_stump(inst, chopper)
	inst:Remove()local item = nil
--10 chance to get rare loot table
	if math.random() < 0.10 then
		local loots = 
--slug bug is incredibly rare, bean bug will be common drop
				{
					jellybug = 8,
					slugbug = 1,
				}
				item = weighted_random_choice(loots)
	end
			if item then
				inst.components.lootdropper:SpawnLootPrefab(item)
	end

				inst.components.lootdropper:SpawnLootPrefab("log")
end
	if GetModConfigData("BUGS") ~= 2 then
for i, prefabname in ipairs(rftrees) do 
AddPrefabPostInit(prefabname, function(inst)
			inst.components.workable:SetOnFinishCallback(dig_up_stump)
end)
end
end
local snakes = { "snake", "snake_poison", "snake_amphibious" }
for i, prefabname in ipairs(snakes) do
AddPrefabPostInit(prefabname, function(inst)
	if inst.components.lootdropper then
		inst.components.lootdropper.numrandomloot = 1
	end
end)
end