name = "Hamlet Changes Redux"
description = "A revised version of my mod which takes up less space and is configurable. Changes aspects of the game for easier and less stressful progression"
author = "juako"
version = "1.3.1"

icon_atlas = "modicon.xml"
icon = "modicon.tex"

forumthread = ""

dont_starve_compatible = true
reign_of_giants_compatible = true
shipwrecked_compatible = true
hamlet_compatible = true

api_version = 6

configuration_options ={
 {
  name = "WEEVOLE",
  label = "W. Cloak changes?",
  options = {
   {description = "Vanilla setting", data = false},
   {description = "Costly but strong", data = true},
   },
  default = true
  },
 {
  name = "VINE",
  label = "Vine tool uses?",
  options = {
   {description = "Vanilla setting", data = false},
   {description = "Halved", data = true},
   },
  default = true
  },
 {
  name = "COWL",
  label = "Cowl repair?",
  options = {
   {description = "Nope!", data = 1},
   {description = "25%", data = 0.25},
   {description = "33%", data = 0.33},
   {description = "50%", data = 0.50},
   },
  default = .25
  },
{
  name = "PEA",
  label = "Gas Mask repair?",
  options = {
   {description = "Nope!", data = 1},
   {description = "25%", data = 0.25},
   {description = "33%", data = 0.33},
   {description = "50%", data = 0.50},
   },
  default = .25
  },
 {
  name = "VAMP",
  label = "Bat Cave spawns?",
  options = {
   {description = "No", data = 0},
   {description = "Yes", data = 1},
   {description = "More!", data = 2},
   },
  default = 0
  },
 {
  name = "SPRINK",
  label = "Sprinkler days?",
  options = {
   {description = "Vanilla setting", data = 1},
   {description = "2 days", data = 2},
   {description = "3 days", data = 3},
   },
  default = 2
  },
 {
  name = "MAGN",
  label = "M. Glass uses?",
  options = {
   {description = "Vanilla setting", data = 10},
   {description = "15", data = 15},
   {description = "20", data = 20},
   {description = "25", data = 25},
   {description = "30", data = 30},
   },
  default = 15
  },
 {
  name = "INGR",
  label = "Ingredient changes?",
  options = {
   {description = "Disabled", data = false},
   {description = "Enabled", data = true},
   },
  default = true
  }, 
{
  name = "RECIPE",
  label = "Crockpot Recipe changes?",
  options = {
   {description = "Disabled", data = false},
   {description = "Enabled", data = true},
   },
  default = true
  }, 
 {
  name = "OINC",
  label = "Oinc splitting?",
  options = {
   {description = "Disabled", data = false},
   {description = "Enabled", data = true},
   },
  default = true
  }, 
 {
  name = "BUGS",
  label = "Bug drop sources?",
  options = {
   {description = "Stumps only", data = 1},
   {description = "G.Grubs only", data = 2},
   {description = "All sources", data = 3},
   },
  default = 3
  }, 
 {
  name = "GRUBLOOT",
  label = "G.Grub loot table?",
  options = {
   {description = "No loot", data = 1},
   {description = "No bugs", data = 2},
   {description = "All loot", data = 3},
   },
  default = 3
  }, 
}



